<!DOCTYPE html>
<html lang="en">
<head>
	<link rel="stylesheet" media="all" href="/site_media/css/chosen.css"/>
	<link rel="stylesheet" media="all" href="pluginMedia/jquery-ui-1.11.4.custom/jquery-ui.min.css"/>
	<link rel="stylesheet" media="all" href="pluginMedia/bootstrap-3.3.5-dist/css/bootstrap.min.css"/>

	<script type="text/javascript" src="pluginMedia/jquery-1.11.3.js"></script>
	<script type="text/javascript" src="pluginMedia/bootstrap-3.3.5-dist/js/bootstrap.min.js"></script>

	<script src="pluginMedia/jquery-ui-1.11.4.custom/jquery-ui.min.js"></script>

	<style type="text/css">
		.helpRight, .helpLeft {
			cursor: default;
			border-bottom: 1px dotted #A9A9A9;
			font-weight: bold;
			text-align: center;
			display: inline-block;
		}

		.dropzone{
			float: left;
			width:86px;
			height:44px;
			border:1px dashed #aaaaaa;
		}
		.dragelement{
			width: 60px;
			height:40px;
			padding-top: 1px;
			padding-bottom: 1px;
			font-size: 12px

		}
		.dropelement{
			margin-top: 1px;
			margin-bottom: 5px;
			margin-right: 5px;
			margin-left: 5px;
		}
		.intable{
			padding:5px;
			margin-top: 5px;
			margin-bottom: 5px;
			margin-right: 30px;
			margin-left: 30px;

		}
		#postbutton{


		}
		input{
			vertical-align: middle;
		}

		.dropdown {
			width: 400px;
		}
		.container {
			width: 700px;
		}
		.zebra:nth-child(odd) {
			background: -moz-linear-gradient(top, rgba(244, 245, 247, 0.75) 0%, rgba(229, 230, 232, 0.75) 50%, rgba(244, 245, 247, 0.75) 100%);
			background: -webkit-gradient(linear, left top, left bottom, color-stop(0%, rgba(244, 245, 247, 0.75)), color-stop(50%, rgba(229, 230, 232, 0.75)), color-stop(100%, rgba(244, 245, 247, 0.75)));
			background: -webkit-linear-gradient(top, rgba(244, 245, 247, 0.75) 0%, rgba(229, 230, 232, 0.75) 50%, rgba(244, 245, 247, 0.75) 100%);
			background: -o-linear-gradient(top, rgba(244, 245, 247, 0.75) 0%, rgba(229, 230, 232, 0.75) 50%, rgba(244, 245, 247, 0.75) 100%);
			background: -ms-linear-gradient(top, rgba(244, 245, 247, 0.75) 0%, rgba(229, 230, 232, 0.75) 50%, rgba(244, 245, 247, 0.75) 100%);
			background: linear-gradient(to bottom, rgba(244, 245, 247, 0.75) 0%, rgba(229, 230, 232, 0.75) 50%, rgba(244, 245, 247, 0.75) 100%);
			filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#bff4f5f7', endColorstr='#bff4f5f7', GradientType=0);

		}
		.header{
			background: -moz-linear-gradient(top,  #eeeeee 0%, #cccccc 100%); /* FF3.6+ */
			background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#eeeeee), color-stop(100%,#cccccc)); /* Chrome,Safari4+ */
			background: -webkit-linear-gradient(top,  #eeeeee 0%,#cccccc 100%); /* Chrome10+,Safari5.1+ */
			background: -o-linear-gradient(top,  #eeeeee 0%,#cccccc 100%); /* Opera 11.10+ */
			background: -ms-linear-gradient(top,  #eeeeee 0%,#cccccc 100%); /* IE10+ */
			background: linear-gradient(to bottom,  #eeeeee 0%,#cccccc 100%); /* W3C */
			filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#eeeeee', endColorstr='#cccccc',GradientType=0 ); /* IE6-9 */

		}
		h6{
			color: red;
		}
		body {
			font-family: "Lucida Grande", "Lucida Sans Unicode", Verdana, Arial, Helvetica, sans-serif;
			font-size: 14px;
		}
	</style>
</head>
<script type='text/javascript'>
	// set up an empty array where the options will  be held
	var selectCode =["","","","","","",""];
	$(document).ready(function(){
		$.ajax({
			url:"/rundb/api/v1/plugin/" + TB_plugin.pk + "?format=json",
			dataType:"json",
			type: "GET",
			async: false,
			success:function(data){
				//get the plugin data
				pluginGET = data;

				//delete the resource_uri
				delete pluginGET.resource_uri;

				$.each(pluginGET.config, function(key,val){
					if(key == "fastqCreate"){
						if (val == "on"){
							document.getElementById("fastqCreate").checked = true;
							document.getElementById("zipFASTQ").disabled = false;
						}
					}
					if (key == "vcfCreate"){
						if (val == "on"){
							document.getElementById("vcfCreate").checked = true;
							document.getElementById("zipVCF").disabled = false;
						}
					}
					if (key == "xlsCreate"){
						if (val == "on"){
							document.getElementById("xlsCreate").checked = true;
							document.getElementById("zipXLS").disabled = false;
						}
					}
					if(key == "bamCreate"){
						if (val == "on"){
							document.getElementById("bamCreate").checked = true;
							document.getElementById("zipBAM").disabled = false;
						}
					}
					if(key == "zipFASTQ"){
						if (val == "on"){
							document.getElementById("zipFASTQ").checked = true;
						}
					}
					if(key == "zipVCF"){
						if (val == "on"){
							document.getElementById("zipVCF").checked = true;
						}
					}
					if(key == "zipXLS"){
						if (val == "on"){
							document.getElementById("zipXLS").checked = true;
						}
					}
					if(key == "zipBAM"){
						if (val == "on"){
							document.getElementById("zipBAM").checked = true;
						}
					}
					if(key == "compressedType"){
						if (val == "zip"){
							document.getElementsByName("compressedType")[0].checked = true;
						} else if (val == "tar"){
							document.getElementsByName("compressedType")[1].checked = true;
						}
					}
					if(key == "delimiter_select"){
						document.getElementById("delimiter_select").value = val;
					}
					if (key == "select_dialog"){
						totalCode = "";
						if (val != null)
							selectCode = val;
						for(each in selectCode){

							if (selectCode[each] != ''){
								eachID= parseInt(each) + 1;
								$("#" + selectCode[each]).appendTo($("#" + eachID));

							}
						}
					}
				});
				//adding drag and drop
				$('.helpLeft').tooltip({"placement": "left"});
				$('.helpRight').tooltip({"placement": "right"});
				$('.dragelement').draggable({ revert: "invalid" });
				$('.dropzone').droppable({
					accept: function(draggable) {
						return $(this).find("*").length == 0;
					},
					drop: function( event, ui ) {
						event.target.style.border = "";
						ui.draggable.css({top: 0,left: 0}).appendTo(event.target);
						updatePreview();
					},
					over: function( event, ui ) {
						event.target.style.border = "1px dotted red";
					},
					out: function( event, ui ) {
						event.target.style.border = "";
					}
				});
				//Adding placeholder
				$("#customInput").each(function(){
					inputText= $(this);
					if(inputText.val()=="" && inputText.attr("placeholder")!=""){
						inputText.val(inputText.attr("placeholder"));

						inputText.focus(function(){
							if(inputText.val()==inputText.attr("placeholder"))
								inputText.val("");

						});
						inputText.blur(function(){
							if(inputText.val()=="")
								inputText.val(inputText.attr("placeholder"));
						});

						inputText.keyup(function(){
							inputText.val(inputText.val().replace(/[^a-zA-Z0-9]/g,""));
						});
					}
				});
				// make sure that appropriate options are disabled/enabled as necessary
				// this also fixes issues when serializing later where disabled options don't auto-serialize
				updatePreview();
				updateTable();

			}

		});
});


	//turn the html objects into json objects
	$.fn.serializeObject = function(){
		var seriObj = {};
		var seriArray = this.serializeArray();

		$.each(seriArray, function() {
			if (seriObj[this.name] != null) {
				if (!seriObj[this.name].push) {
					seriObj[this.name] = [seriObj[this.name]];
				}

				seriObj[this.name].push(this.value || '');
			}
			else {
				seriObj[this.name] = this.value || '';
			}
		});

		return seriObj;
	};
	//update the interface as they click the buttons.
    //allow the to compress a file only if they clicked to generate it
    function updateTable() {
    	readyToSubmit = false;
    	if (document.getElementById("bamCreate").checked == true) {
    		document.getElementById("zipBAM").disabled = false;
    		readyToSubmit = true;
    	}
    	else {
    		document.getElementById("zipBAM").disabled = true;
    		document.getElementById("zipBAM").checked = false;
    	}
    	if (document.getElementById("vcfCreate").checked == true) {
    		document.getElementById("zipVCF").disabled = false;
    		readyToSubmit = true;
    	}
    	else {
    		document.getElementById("zipVCF").disabled = true;
    		document.getElementById("zipVCF").checked = false;
    	}
    	if (document.getElementById("xlsCreate").checked == true) {
    		document.getElementById("zipXLS").disabled = false;
    		readyToSubmit = true;
    	}
    	else {
    		document.getElementById("zipXLS").disabled = true;
    		document.getElementById("zipXLS").checked = false;
    	}
    	if (document.getElementById("fastqCreate").checked == true) {
    		document.getElementById("zipFASTQ").disabled = false;
    		readyToSubmit = true;
    	}
    	else {
    		document.getElementById("zipFASTQ").disabled = true;
    		document.getElementById("zipFASTQ").checked = false;
    	}

    	if (readyToSubmit){
    		//$("#postbutton").show();
    		$("#postbutton").prop('disabled', false);
    	}
    	else{
    		//$("#postbutton").hide();
    		$("#postbutton").prop('disabled', true);
    	}
    }

    function updatePreview() {
    	var i, j, count =0;
    	for(i = 0, j =1; i<7; i++, j++){
    		if( $('#' + j).children().length > 0 ){
    			if($('#' + j).children().attr('id') == "customButton")
    				selectCode[i] =$("#customInput").val();
    			else
    				selectCode[i] = $('#' + j).children().attr('id');
    			count++;
    		}
    		else{
    			selectCode[i] = '';
    		}

    	}

    	if(count > 3)
    		document.getElementById("warn").style.color= "red";
    	else
    		document.getElementById("warn").style.color= "white";

    	previewOut= '';
    	for (var sel in selectCode){
    		if(selectCode[sel] != ''){
    			previewOut += selectCode[sel];
    			previewOut += document.getElementById("delimiter_select").value;
    		}
    	}

    	if(previewOut != ''){
    		previewOut = previewOut.substring(0, previewOut.length - 1);
    		previewOut += ".bam";
    	}
    	else{
    		previewOut = "No options selected"
    	}
    	$("#previewplace").html(previewOut);
    }

    $(function() {
    	$('#postbutton').click(function() {
    		$('#postbutton').attr('disabled','disabled');
    		$("#postbutton").val("Submitting...");
    		obj = $('#bamform').serializeObject();
    		console.log(obj);
    		if (!document.getElementById("bamCreate").checked)
    			obj["bamCreate"] = 'off';
    		if (!document.getElementById("vcfCreate").checked)
    			obj["vcfCreate"] = 'off';
    		if (!document.getElementById("xlsCreate").checked)
    			obj["xlsCreate"] = 'off';
    		if (!document.getElementById("fastqCreate").checked)
    			obj["fastqCreate"] = 'off';
    		if (!document.getElementById("zipBAM").checked)
    			obj["zipBAM"] = 'off';
    		if (!document.getElementById("zipVCF").checked)
    			obj["zipVCF"] = 'off';
    		if (!document.getElementById("zipXLS").checked)
    			obj["zipXLS"] = 'off';
    		if (!document.getElementById("zipFASTQ").checked)
    			obj["zipFASTQ"] = 'off';

    		if (document.getElementsByName("compressedType")[0].checked)
    			obj["compressedType"] = 'zip';
    		else if (document.getElementsByName("compressedType")[1].checked)
    			obj["compressedType"] = 'tar';

    		obj['select_dialog'] = selectCode;
    		pluginAPIJSON = { "plugin" : [TB_plugin.fields.name], "pluginconfig" : obj };
    		pluginAPIJSON = JSON.stringify(pluginAPIJSON);
    		pluginURL = "/rundb/api/v1/results/" + TB_result + "/plugin/";
    		$.ajax({
    			type: 'POST',
    			url: pluginURL,
    			contentType: "application/json; charset=utf-8",
    			data: pluginAPIJSON,
    			error: function(data) { console.log('error', data)},
    			success: function(data) {
    				$("#postbutton").val("Submitted");
    				$("#json_result").html('<div style="text-align:center;"><img src="/site_media/jquery/colorbox/images/loading.gif" alt="Running Plugin" style="float:center"></img><p>Running the Plugin...</p></div>');
    				setTimeout("parent.$.fn.colorbox.close()", 2500);
    			}
    		})
    	});
})

</script>
<body>
	<form id="bamform" name="bamform" align="left" class="container">
		<div class="row-fluid" style="margin-bottom:0px">
			<div class="span8">
				<h2>My Plugin</h2>
			</div>
			<div style="margin-top:14px;display:none"></div>
		</div>
		<h4>File Options:</h4>
		<table class="table table-bordered" >
			<thead>
				<tr class ="header">
					<th><div style="text-align: center;">File Types:</div></th>
					<th><div style="text-align: center;">Include:</div></th>
					<th><div style="text-align: center;">Archive:</div></th>
				</tr>
			</thead>

			<tbody>
				<tr class="zebra">
					<td><div class="row-fluid" style="text-align: center;">
						<span class="helpLeft" title="Binary Sequence Alignment/Map (BAM), is a compressed, binary form of the SAM format. BAM files can be indexed, using the BAM Index file, for quick access to sequence alignment data.">BAM</span>
					</div></td>

					<td><div class="row-fluid" style="text-align: center;">
						<input type="checkbox" id="bamCreate"name="bamCreate" onchange="updateTable()"/></td>
					</div>
					<td><div class="row-fluid" style="text-align: center;">
						<input type="checkbox"id="zipBAM" name="zipBAM" disabled="disabled"/></td>
					</div>
				</tr>


				<tr class="zebra">
					<td><div class="row-fluid" style="text-align: center;">
						<span class="helpLeft" title="VCF is a text file that contains meta-information lines, a header line, and then data lines each containing information about a position in the genome. The format also has the ability to contain genotype information on samples for each position. This file is generated by Variant Caller">Variant Call Format (VCF)</span>
					</div></td>

					<td><div class="row-fluid" style="text-align: center;">
						<input type="checkbox" id="vcfCreate"name="vcfCreate" onchange="updateTable()"/></td>
					</div>
					<td><div class="row-fluid" style="text-align: center;">
						<input type="checkbox"id="zipVCF" name="zipVCF" disabled="disabled"/>
					</div>
				</tr>

				<tr class="zebra">
					<td><div class="row-fluid" style="text-align: center;">
						<span class="helpLeft" title="The XLS is a excel file that contains meta-information lines, a header line, and then data lines each containing information about a position in the genome. The format also has the ability to contain genotype information on samples for each position. This file is generated by Variant Caller">Variant Caller Excel File (XLS)</span>
					</div></td>

					<td><div class="row-fluid" style="text-align: center;">
						<input type="checkbox" id="xlsCreate"name="xlsCreate" onchange="updateTable()"/></td>
					</div>
					<td><div class="row-fluid" style="text-align: center;">
						<input type="checkbox"id="zipXLS" name="zipXLS" disabled="disabled"/>
					</div>
				</tr>

				<tr class="zebra">
					<td><div class="row-fluid" style="text-align: center;">
						<span class="helpLeft" title='FASTQ-formatted file containing data organized in a per-base basis, including quality scores. The reads contained in the file are unaligned reads. It file contains a sequence header followed by a line of sequence then by a quality header and another line of quality metrics. The sequence header line always starts with a "@" directly followed by a unique identifier and the quality header always starts with a "+"'>FASTQ</span>
					</div></td>
				</div></td>
				<td><div class="row-fluid" style="text-align: center;">
					<input type="checkbox" id="fastqCreate" name="fastqCreate" onchange="updateTable()"/></td>
				</div>
				<td><div class="row-fluid" style="text-align: center;">
					<input type="checkbox" id="zipFASTQ" name="zipFASTQ" disabled="disabled"/></td>
				</div>
			</tr>

		</tbody>
	</table>
	<div class="row-fluid">
		<div class="span3"><span class="helpRight" title="If you choose to have the file compressed, it can either be put into a zip file or a tar.bz2 file. Ignore this if you do not want it to be archived at all.">Archive File Type:</span></div>
		<div class="span8">
			<div style="float:left;margin-right:30px">
				<label>
					<input type="radio" name="compressedType" style="vertical-align:baseline" value="zip" checked>
					zip
				</label>
			</div>
			<div style="float:left;margin-right:30px">
				<label>
					<input type="radio" name="compressedType" style="vertical-align:baseline" value="tar">
					tar.bz2
				</label>
			</div>
		</div>
	</div>
	<br><br>
	<h4>Name Options:</h4>
	<div class="row-fluid">
		<div class="span3"><span class="helpRight" title="If you want to add your own naming option, enter the text here. Only alphanumeric characters allowed.">Custom Name Option:</span></div>
		<div class="span4">
			<input id="customInput" placeholder="Enter Text Here" maxlength="20">
		</div>
		<div class="span1">
			<span type="button" id="updateButton" class="btn" onclick="updatePreview()">Update</span>
		</div>

	</div>
	<br>

	<table class="table table-bordered"  style="text-align: center;">
		<thead>
			<tr class="header">
				<th><div style="text-align: center;" class="helpRight" title="Drag and drop selections from table to boxes below">Selections:</div></th>
				<th></th><th></th><th></th>
			</tr>
		</thead>

		<tbody name="select_dialog" class="zebra">
			<tr>
				<td ><div class="dropzone intable row-fluid" style="text-align: center;">
					<span type="button" id="run_name" text="runname" class="btn btn-primary active dragelement">Run Name</span>
				</div></td>
				<td class="zebra"><div class="dropzone intable row-fluid" style="text-align: center;">
					<span type="button" id="report_name" text="reportname" class="btn btn-primary active dragelement">Report Name</span>
				</div></td>
				<td><div class="dropzone intable row-fluid" style="text-align: center;">
					<span type="button" id="run_date" text="reportdate" class="btn btn-primary active dragelement">Report Date</span>
				</div></td>
				<td><div class="dropzone intable row-fluid" style="text-align: center;">
					<span type="button" id="chiptype" class="btn btn-primary active dragelement">Chip Type</span>
				</div></td>
			</tr>
			<tr class="zebra" style="text-align: center;" >
				<td><div class="dropzone intable row-fluid" style="text-align: center;">
					<span type="button" id="instrument" class="btn btn-primary active dragelement">Sequencer Name</span>
				</div></td>
				<td><div class="dropzone intable row-fluid" style="text-align: center;">
					<span type="button" id="samplename" class="btn btn-primary active dragelement">Sample Name</span>
				</div></td>
				<td><div class="dropzone intable row-fluid" style="text-align: center;">
					<span type="button" id="barcodename"  class="btn btn-primary active dragelement">Barcode Name</span>
				</div></td>
				<td><div class="dropzone intable row-fluid" style="text-align: center;">
					<span type="button" id="customButton"class="btn btn-primary active dragelement">Custom Name</span>
				</div></td>
			</tr>
		</tbody>
	</table>
	<div>
		<div class="dropzone dropelement" id= "1"></div>
		<div class="dropzone dropelement" id= "2" ></div>
		<div class="dropzone dropelement" id= "3" ></div>
		<div class="dropzone dropelement" id= "4" ></div>
		<div class="dropzone dropelement" id= "5" ></div>
		<div class="dropzone dropelement" id= "6" ></div>
		<div class="dropzone dropelement" id= "7" ></div>
		<br><br>
	</div>
	<br><br>
	<span>
		<div class="row-fluid">
			<div class="span3">
				<span class="helpRight"
				title="This will be how the naming options will be seperated. Once you choose more than one naming option, you will be able to see,in the preview area, what the delimiter will look like.">
				Delimiters:
			</span>
		</div>
		<div class="span8">
			<select id="delimiter_select" name="delimiter_select" class="dropdown long"  onchange="updatePreview()">
				<option value=".">.</option>
				<option value="-">-</option>
				<option value="_">_</option>
			</select>
			<div class="span1"></div>
		</div>
	</div>
</span>

<h4>Example Name:</h4>
<span id="previewplace"></span>
<br><br>
<h6 id="warn">Warning: The name you have choosen may be too long. You may encounter problems when downloading.</h6>
<br><br>
</form>
<div class="container">
	<input id="postbutton" type="submit" name="submit" postbutton="Submit" value="Submit">
	<br><br><br>
</div>

</body>
</html>
